# BEGIN SourceDeps(oneline):
BuildRequires: /usr/bin/bison /usr/bin/expect /usr/bin/m4 /usr/bin/makeinfo /usr/bin/runtest flex gcc-c++ perl(Exporter.pm) perl(FileHandle.pm) perl(FindBin.pm) perl(IPC/Open2.pm)
# END SourceDeps(oneline)
%define target msp430

Name:		%{target}-gcc
Version:	4.6.3
Release:	alt1_2
Summary:	Cross Compiling GNU GCC targeted at %{target}
Group:		Development/Other
License:	GPLv2+
URL:		http://mspgcc.sf.net/
Source0:	ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-core-%{version}.tar.bz2

# Patch from mspgcc project
Patch0:		msp430-gcc-4.6.3-20120406.patch


# We need the uniarch variant of binutils
# which was shipped as 2.21.1a-1 in Fedora
BuildRequires:	%{target}-binutils >= 2.21.1a-1
BuildRequires:	libgmp-devel libgmp_cxx-devel libmpfr-devel libmpc-devel
Requires:	%{target}-binutils >= 2.21.1a-1
Provides: bundled(libiberty)
Source44: import.info

%description
This is a cross compiling version of GNU GCC, which can be used to
compile for the %%{target} platform, instead of for the native %%{_arch} 
platform.

%prep
%setup -q -c -n msp430-gcc
pushd gcc-%{version}
%patch0 -p1
popd

# Extract %%__os_install_post into os_install_post~
cat << \EOF > os_install_post~
%__os_install_post
EOF

# Generate customized brp-*scripts
cat os_install_post~ | while read a x y; do
case $a in
# Prevent brp-strip* from trying to handle foreign binaries
*/brp-strip*)
  b=$(basename $a)
  sed -e 's,find $RPM_BUILD_ROOT,find $RPM_BUILD_ROOT%_bindir $RPM_BUILD_ROOT%_libexecdir,' $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm.*/brp-strip,./brp-strip,' \
< os_install_post~ > os_install_post 


%build
mkdir gcc-%{version}-build
cd gcc-%{version}-build
CC="%{__cc} ${RPM_OPT_FLAGS}" ../gcc-%{version}/configure \
	--libexecdir=%_libexecdir \
	--prefix=%{_prefix} --mandir=%{_mandir} \
	--infodir=%{_infodir} --target=%{target} --disable-nls \
	--libdir=%{_libdir} --enable-version-specific-runtime-libs \
	--enable-languages=c
# Building GCC-3.2.3 is not smp-safe
make


%install
make -C gcc-%{version}-build install DESTDIR=$RPM_BUILD_ROOT

# we don't want these as we are a cross version
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -rf $RPM_BUILD_ROOT%{_mandir}/man7
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a

%define __os_install_post . ./os_install_post


%files
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{target}/
%dir %{_libdir}/gcc/%{target}/%{version}/
%dir %{_libdir}/gcc/%{target}/mcpu-430x
%dir %{_libdir}/gcc/%{target}/mmpy-16
%dir %{_libexecdir}/gcc/%{target}/%{version}

%{_bindir}/%{target}-*
%{_libdir}/gcc/%{target}/%{version}/*
%{_mandir}/man1/%{target}-*.1*
%{_libexecdir}/gcc/%{target}/%{version}/*


%changelog
* Sat Feb 09 2013 Igor Vlasenko <viy@altlinux.ru> 4.6.3-alt1_2
- initial fc import

